require 'rack'

module AuthenticationIdentifierTransposer
  class RackMiddleware
    def initialize(app)
      @app = app
    end

    def call(env)
      request = Rack::Request.new env
      authenticated_identifier = request.env['HTTP_X_GATEWAY_AUTHENTICATED_IDENTIFIER']
      if authenticated_identifier
        request.session['user']    = authenticated_identifier
        request.env['REMOTE_USER'] = authenticated_identifier
      end
      return @app.call env
    end
  end
end
